<?php
/**
 * @name SHCMS Engine
 * @copyright Shamsik © 2012
 * Данный код защищен авторскими правами
 * http://shcms.ru
 */
 
final class SHCMS_Version 
{
       //Версия скрипта
       const VERSION = '1.0.18';
       //Техническое обслуживание версию.
       const MAINTENANCE = '0';
       //Название скрипта
       const PRODUCT = 'SHCMS Engine';
       //Дата выпуска
       const RELEASE_DATE = '10 мая 2013г';
       //Время выпуска
       const RELEASE_TIME = '12:18';
       //Часовой пояс
       const RELEASE_TIME_ZONES = 'GWP';
       //Копирайт
       const COPYRIGHT = 'Copyright © 2012 Powered by SHCMS Engine. Все права защищены.';
       //Официальный сайт
       const SITE = '<a href="http://shcms.ru">SHCMS Engine</a>';
       //Автор Скрипта
       const AUTHOR = 'Shamsik (Шамсик)';

    /**
	*
    * Сравнивает два "PHP стандартизированных" Номер версии от текущей версии SHCMS Engine.
	*
    */
    public static function Compatible($mini) {
        return (version_compare(self::getShort(),$mini,'eq') == 1);
    }
    /**
    * Получает "PHP стандартизированной» версии строки для текущего движка SHCMS Engine
    *
    * @ Возвращение строки версии строки.
    *
    */
	
    public static function getShort() {
        return self::VERSION .'. ('. self::MAINTENANCE .')';
    }
    /**
    * Получает строку версии для текущего движка SHCMS Engine со всеми релизе информации.
    *
    * @ Вернуть строку Полная версия строки.
    *
    */
	
    public static function getLong() {
        return self::PRODUCT . ' ' . self::VERSION . '.' . self::MAINTENANCE . ' ' . self::RELEASE_DATE . ' '. self::RELEASE_TIME .' ' . self::RELEASE_TIME_ZONES;
    }

    /**
    * Получает копирайта и автора скрипта SHCMS Engine
    *
    * @ Вернуть строку Полная версия строки.
    *
    */
 
    public static function getCopyrightSite()
    {
        return self::COPYRIGHT . ' &nbsp'. self::SITE . '<br/>Автор: ' . self::AUTHOR;
    }
	
	        // Проверка доступности новой версии	
	public static function New_Version() {

	        if( $curl = curl_init() ){
		        curl_setopt($curl,CURLOPT_URL,'http://shcms.ru/down/version.dat');
		        curl_setopt($curl,CURLOPT_RETURNTRANSFER,true);
		        $out = curl_exec($curl);
		        echo $out;
        	}
	
	}
	
 
}


?>